
#include <cmath>
#include <iostream>
#include <fstream>
#include <string>

using namespace std;

int node_id;
int element_id;
int slice_size;
int edge_size;
#define SLICE_NUMBER 2

  // --------------------------------------------------------------------------
  // Write a node.
void w_node( ofstream* output, double x, double y, double z )
{
  ++ node_id;
  
  (*output) << node_id << ", " << x << ", " << y << ", " << z << endl;
}

void w_element( ofstream* output, int x, int y, int z )
{
  ++ element_id;
  
  int n1 = z * slice_size + y * edge_size + x;
  int n2 = z * slice_size + y * edge_size + x + 1;
  int n3 = z * slice_size + ( y + 1 ) * edge_size + x + 1;
  int n4 = z * slice_size + ( y + 1 ) * edge_size + x;
  
  int n5 = ( z + 1 ) * slice_size + y * edge_size + x;
  int n6 = ( z + 1 ) * slice_size + y * edge_size + x + 1;
  int n7 = ( z + 1 ) * slice_size + ( y + 1 ) * edge_size + x + 1;
  int n8 = ( z + 1 ) * slice_size + ( y + 1 ) * edge_size + x;
  
  (*output) << element_id << ", " << n1 << ", " << n2 << ", " << n3 << ", "
            << n4 << ", " << n5 << ", " << n6 << ", " << n7 << ", " << n8
			<< endl;
}

  // --------------------------------------------------------------------------
  // Main program.
int main( int argc, char** argv )
{
  cerr << "program started" << endl;
  
  if ( argc != 3 )
  {
    cerr << "Usage: " << argv[ 0 ] << " intput.txt output.in" << endl;
	return 1;
  }
  char *input_file = argv[ 1 ];
  char *output_file = argv[ 2 ];
  
  node_id = 0;
  element_id = 0;
  
    // Open input file.
  ifstream *input = new ifstream;
  input->open( input_file );
  
    // Input file size.
  input->seekg ( 0, ios::beg );
  long input_size = 0;
  long bone_size = 0;
  char c = 0;
  while ( 1 )
  {
    (*input) >> c;
	
	if ( input->eof() )
	{
	  break;
	}
	
	if ( c == '0' || c == '1' )
	{
	  ++ input_size;
	  if ( c == '1' )
	  {
	    ++ bone_size;
	  }
	}
  }
  cerr << "Input file size: " << input_size << endl;
  cerr << "Bone size: " << bone_size << endl;
  
    // Cubuc root of the input size is the edge size of our matrix data.
  // double edge_size_d = pow( (double)input_size, ( 1.0 / 3.0 ) );
  // cerr << "Edge double: " << edge_size_d << endl;
  // edge_size = (int)floor( edge_size_d + 0.5 );
  edge_size = 3;  // !!!
  /*
  if ( input_size != ( edge_size * edge_size * SLICE_NUMBER ) )
  {
    cerr << "ERROR: Input file contains non-cube number of voxels!" << endl;
	cerr << "Edge size: " << edge_size << endl;
	return 1;
  }
  */
  
  cerr << "Edge size: " << edge_size << endl;
  cerr << endl;
  slice_size = edge_size * edge_size;
  
    // Read input data.
  input->close();
  delete input;
  input = new ifstream;
  input->open( input_file );
  int rid_bone = 0;
  int rid_fat = 0;
  cerr << "Reading input data..." << endl;
  // input->seekg ( 0, ios::beg );
  int stop = edge_size * edge_size * SLICE_NUMBER;
  
  char *data = new char[ stop ];
  int ii = 0;
  
  while ( 1 )
  {
    (*input) >> c;
	
	if ( input->eof() || ii >= stop )
	{
	  break;
	}
	
    if ( c == '0' )
	{
	  data[ ii ] = 0;
	  ++ ii;
	  rid_fat ++;
	}
	else
	{
	  // cerr << (int)c << " ";
	  data[ ii ] = 1;
	  ++ ii;
	  rid_bone ++;
	}
  }
  cerr << "  " << rid_bone << " bone elements read." << endl;
  cerr << "  " << rid_fat << " fat elements read." << endl;
  cerr << endl;
  
    // Close input file.
  input->close();
  delete input;
  
  // OUTPUT *******************************************************************
  
    // Open output file.
  ofstream *output = new ofstream;
  output->open( output_file );
  
    // Nodes.
  (*output) << "*NODE, NSET=Nall" << endl
            << endl;
  cerr << "Writing nodes...";
  int n_edge_size = edge_size + 1;
  int n_stop = n_edge_size * n_edge_size * ( SLICE_NUMBER + 1 );
  int n_slice_size = n_edge_size * n_edge_size;
  for ( int i = 0; i < ( n_stop ); ++ i )
  {
    int x = i % n_edge_size;
	int z = i / n_slice_size;
	int y = ( i - z * n_slice_size ) / n_edge_size;
	w_node( output, x, y, z );
  }
  cerr << " Done." << endl;
  
    // Bone elements.
  int n_bone = 0;
  cerr << "Writing bone elments... ";
  (*output) << "*ELEMENT, TYPE=C3D8R, ELSET=Bone" << endl;
  for ( int i = 0; i < stop; ++ i )
  {
    int x = i % n_edge_size;
	int z = i / n_slice_size;
	int y = ( i - z * n_slice_size ) / n_edge_size;
    if ( data[ i ] == 1 )
	{
	  w_element( output, x, y, z );
	  ++ n_bone;
	}
  }
  cerr << "Done." << endl << "  " << n_bone << " bone elements written." << endl;
  
    // Liquid elements.
  int n_liq = 0;
  cerr << "Writing fat elements... ";
  (*output) << "*ELEMENT, TYPE=C3D8R, ELSET=Fat" << endl;
  for ( int i = 0; i < stop; ++ i )
  {
    int x = i % n_edge_size;
	int z = i / n_slice_size;
	int y = ( i - z * n_slice_size ) / n_edge_size;
    if ( data[ i ] == 0 )
	{
	  w_element( output, x, y, z );
	  ++ n_liq;
	}
  }
  cerr << "Done." << endl << "  " << n_liq << " fat elements written." << endl;
  
  (*output) << "*NSET,NSET=Nfix" << endl;
  for ( int i = 0; i < edge_size * edge_size; ++ i )
  {
    (*output) << i+1 << ", " << endl;
  }
  (*output) << "*BOUNDARY" << endl
            << "Nfix,1,3" << endl
	        << endl;
    // Material properties.
  (*output) << "*MATERIAL,NAME=MBone" << endl
            << "*ELASTIC" << endl
            << "210000.,.3" << endl
            << "*DENSITY" << endl
            << "7.8e-9" << endl
            << "*SOLID SECTION,ELSET=Bone,MATERIAL=MBone" << endl
            << endl;
   (*output) << "*MATERIAL,NAME=MFat" << endl
            << "*ELASTIC" << endl
            << "21000.,.3" << endl
            << "*DENSITY" << endl
            << "7.8e-9" << endl
            << "*SOLID SECTION,ELSET=Fat,MATERIAL=MFat" << endl
            << endl;
			
  (*output) << "**" << endl
            << "*STEP" << endl
            << "*STATIC" << endl
            << "*CLOAD" << endl;
            // << "8,3,-1. " << endl
  for ( int i = 0; i < edge_size * edge_size; ++ i )
  {
    (*output) << ( i + edge_size * edge_size * ( SLICE_NUMBER - 1 ) + 1 ) << ",3,-1. " << endl;
  }

			
  (*output) << "*NODE PRINT,NSET=Nall" << endl
            << "U" << endl
			<< endl;
			
  (*output) << "*EL PRINT,ELSET=Bone" << endl
            << "S" << endl
			<< endl;
			
  (*output) << "*EL PRINT,ELSET=Fat" << endl
            << "S" << endl
			<< endl;
			
  (*output) << "*END STEP" << endl
			<< endl;
  
    // Close output file.
  output->close();
  delete output;
  
  delete data;
  return 0;
}
